#define MAX_PARTS	10

float cam_x,cam_y;

void Viewi(){

	glLoadIdentity();
	glTranslatef(-cam_x*4,cam_y*4,-1);
}

typedef struct
{
	float x,y,z;
	float xg,yg,zg;
	float life;

}tsParticle;
tsParticle debris[MAX_PARTS+1];
tsParticle bparts[MAX_PARTS+1];
int debris_index,bparts_index;

void PutDebris()
{
	int i;
	for(i=0;i<7;i++)
	{
		debris_index++;
		if(debris_index>MAX_PARTS)
			debris_index=1;
			
		debris[debris_index].x=player.x*4;
		debris[debris_index].y=-player.y*4;
		debris[debris_index].z=0;
		debris[debris_index].xg=50-rand()%100;
		debris[debris_index].yg=50-rand()%100;
		debris[debris_index].zg=50-rand()%100;
		debris[debris_index].xg/=500;
		debris[debris_index].yg/=500;
		debris[debris_index].zg/=500;
		debris[debris_index].life=1;
	
	}
}
void PutBparts()
{
	int i;
	for(i=0;i<7;i++)
	{
		bparts_index++;
		if(bparts_index>MAX_PARTS)
			bparts_index=1;
			
		bparts[bparts_index].x=player.x*4;
		bparts[bparts_index].y=-player.y*4;
		bparts[bparts_index].z=0;
		bparts[bparts_index].xg=50-rand()%100;
		bparts[bparts_index].yg=50-rand()%100;
		bparts[bparts_index].zg=50-rand()%100;
		bparts[bparts_index].xg/=1000;
		bparts[bparts_index].yg/=1000;
		bparts[bparts_index].zg/=1000;
		bparts[bparts_index].life=1;
	
	}
}
void DrawParts()
{
	int i;
	PA_Texture(0);
	
	for(i=1;i<MAX_PARTS;i++)
	{
		
		
		if(debris[i].life>0)
		{
			glColor3f(0.5,0.5,0.5);
			
			debris[i].life-=0.03;
			debris[i].x+=debris[i].xg;
			debris[i].y+=debris[i].yg;
			debris[i].z+=debris[i].zg;
			debris[i].xg*=0.99;
			debris[i].zg*=0.99;
			debris[i].yg-=0.01;
			
			Viewi();
			
			float size=2*debris[i].life;
				glBegin(GL_TRIANGLES);
					glVertex3f(debris[i].x,debris[i].y,debris[i].z-1);
					glVertex3f(debris[i].x+debris[i].xg*size,debris[i].y+debris[i].yg*size,debris[i].z-1);
					glVertex3f(debris[i].x+debris[i].xg*size+0.05,debris[i].y+debris[i].yg*size,debris[i].z-1);
				glEnd();
				
		}
		
		
		
		if(bparts[i].life>0)
		{	
			glColor3f(1,1,0);
			
			bparts[i].life-=0.03;
			bparts[i].x+=bparts[i].xg;
			bparts[i].y+=bparts[i].yg;
			bparts[i].z+=bparts[i].zg;
			bparts[i].xg*=0.99;
			bparts[i].zg*=0.99;
			bparts[i].yg-=0.003;
			
			float size=2*bparts[i].life;
			Viewi();
				glBegin(GL_TRIANGLES);
					glVertex3f(bparts[i].x+0.001,bparts[i].y,bparts[i].z-1);
					glVertex3f(bparts[i].x+bparts[i].xg*size,bparts[i].y+bparts[i].yg*size,bparts[i].z-1);
					glVertex3f(bparts[i].x+bparts[i].xg*size+0.05,bparts[i].y+bparts[i].yg*size,bparts[i].z-1);
				glEnd();
		}
	}
}



void tsCube()
{
	glBegin(GL_QUAD);
		// Front Face
		//glNormal3f( 0.0f, 0.0f, 1.0f);// Normal Pointing Towards Viewer
		glTexCoord2f(0.0f,0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);// Point 1 (Front)
		glTexCoord2f(1.0f,0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);// Point 2 (Front)
		glTexCoord2f(1.0f,1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);// Point 3 (Front)
		glTexCoord2f(0.0f,1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);// Point 4 (Front)
		// Back Face
		//glNormal3f( 0.0f, 0.0f,-1.0f);// Normal Pointing Away From Viewer
		glTexCoord2f(1.0f,0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);// Point 1 (Back)
		glTexCoord2f(1.0f,1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);// Point 2 (Back)
		glTexCoord2f(0.0f,1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);// Point 3 (Back)
		glTexCoord2f(0.0f,0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);// Point 4 (Back)
		// Top Face
		//glNormal3f( 0.0f, 1.0f, 0.0f);// Normal Pointing Up
		glTexCoord2f(0.0f,1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);// Point 1 (Top)
		glTexCoord2f(0.0f,0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);// Point 2 (Top)
		glTexCoord2f(1.0f,0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);// Point 3 (Top)
		glTexCoord2f(1.0f,1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);// Point 4 (Top)
		// Bottom Face
		//glNormal3f( 0.0f,-1.0f, 0.0f);// Normal Pointing Down
		glTexCoord2f(1.0f,1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);// Point 1 (Bottom)
		glTexCoord2f(0.0f,1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);// Point 2 (Bottom)
		glTexCoord2f(0.0f,0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);// Point 3 (Bottom)
		glTexCoord2f(1.0f,0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);// Point 4 (Bottom)
		// Right face
		//glNormal3f( 1.0f, 0.0f, 0.0f);// Normal Pointing Right
		glTexCoord2f(1.0f,0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);// Point 1 (Right)
		glTexCoord2f(1.0f,1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);// Point 2 (Right)
		glTexCoord2f(0.0f,1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);// Point 3 (Right)
		glTexCoord2f(0.0f,0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);// Point 4 (Right)
		// Left Face
		//glNormal3f(-1.0f, 0.0f, 0.0f);// Normal Pointing Left
		glTexCoord2f(0.0f,0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);// Point 1 (Left)
		glTexCoord2f(1.0f,0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);// Point 2 (Left)
		glTexCoord2f(1.0f,1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);// Point 3 (Left)
		glTexCoord2f(0.0f,1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);// Point 4 (Left)
	glEnd();

}

void DrawScene()
{
	PA_Texture(tunnelitex);// tunneli
	
	int i,step=7;
	float r,s=1.72;
	float step2=6.282/8;
	
	s=1;
	
	
	if(player.z<512-step){
	// pputki
	glColor3f(1,1,1);
	for(i=step;i<512-step;i+=step)
	{
		if(i>player.z-step && i<player.z+25)
		{	
			for(r=0;r<6.282;r+=step2)
			{
					float x=level1.free_place[i].x*4;
					float y=level1.free_place[i].y*4;
					float x2=level1.free_place[i-step].x*4;
					float y2=level1.free_place[i-step].y*4;
					
				Viewi();
								
				glTranslatef(0,0,-i+player.z);
				
				float u1=0;
				float u2=1;
				float v1=(r)/6.282;
				float v2=(r+step2)/6.282;
				
				glBegin(GL_QUADS);
					glTexCoord2f(u1,v1*2);	glVertex3f(x+sin(r)*s,			y+cos(r)*s,			0);
					glTexCoord2f(u2,v1*2);	glVertex3f(x2+sin(r)*s,		y2+cos(r)*s,		step);
					glTexCoord2f(u2,v2*2);	glVertex3f(x2+sin(r+step2)*s,	y2+cos(r+step2)*s,	step);
					glTexCoord2f(u1,v2*2);	glVertex3f(x+sin(r+step2)*s,	y+cos(r+step2)*s,	0);
				glEnd();
				
			}
		}
	}
	// pikkuputki
/*	
	float ol_s=s;
	s=0.1;
	ol_s-=s*2;
	step2=6.282/3;
	
	glColor3f(0.8,0.8,0.8);
	
	for(i=step;i<512-step;i+=step)
	{
		if(i>player.z-step && i<player.z+25)
		{
		
			
				
			for(r=0;r<6.282;r+=step2)
			{
					float x=level1.free_place[i].x*4;
					float y=level1.free_place[i].y*4;
					float x2=level1.free_place[i-step].x*4;
					float y2=level1.free_place[i-step].y*4;
					
				Viewi();
								
				glTranslatef(0,0,-i+player.z);
				
				float u1=0;
				float u2=1/2;
				float v1=((r)/6.282)/2;
				float v2=((r+step2)/6.282)/2;
				
				glBegin(GL_QUADS);
					glTexCoord2f(u1,v1);	glVertex3f((-ol_s)+x+sin(r)*s,			y+cos(r)*s,			0);
					glTexCoord2f(u2,v1);	glVertex3f((-ol_s)+x2+sin(r)*s,		y2+cos(r)*s,		step);
					glTexCoord2f(u2,v2);	glVertex3f((-ol_s)+x2+sin(r+step2)*s,	y2+cos(r+step2)*s,	step);
					glTexCoord2f(u1,v2);	glVertex3f((-ol_s)+x+sin(r+step2)*s,	y+cos(r+step2)*s,	0);
				glEnd();
				glBegin(GL_QUADS);
					glTexCoord2f(u1,v1);	glVertex3f((ol_s)+x+sin(r)*s,			y+cos(r)*s,			0);
					glTexCoord2f(u2,v1);	glVertex3f((ol_s)+x2+sin(r)*s,		y2+cos(r)*s,		step);
					glTexCoord2f(u2,v2);	glVertex3f((ol_s)+x2+sin(r+step2)*s,	y2+cos(r+step2)*s,	step);
					glTexCoord2f(u1,v2);	glVertex3f((ol_s)+x+sin(r+step2)*s,	y+cos(r+step2)*s,	0);
				glEnd();
				
				glBegin(GL_QUADS);
					glTexCoord2f(u1,v1);	glVertex3f(-s*2+x+sin(r)*s,			(-ol_s)+y+cos(r)*s,			0);
					glTexCoord2f(u2,v1);	glVertex3f(-s*2+x2+sin(r)*s,		(-ol_s)+y2+cos(r)*s,		step);
					glTexCoord2f(u2,v2);	glVertex3f(-s*2+x2+sin(r+step2)*s,	(-ol_s)+y2+cos(r+step2)*s,	step);
					glTexCoord2f(u1,v2);	glVertex3f(-s*2+x+sin(r+step2)*s,	(-ol_s)+y+cos(r+step2)*s,	0);
				glEnd();
				glBegin(GL_QUADS);
					glTexCoord2f(u1,v1);	glVertex3f(s*2+x+sin(r)*s,			(-ol_s)+y+cos(r)*s,			0);
					glTexCoord2f(u2,v1);	glVertex3f(s*2+x2+sin(r)*s,		(-ol_s)+y2+cos(r)*s,		step);
					glTexCoord2f(u2,v2);	glVertex3f(s*2+x2+sin(r+step2)*s,	(-ol_s)+y2+cos(r+step2)*s,	step);
					glTexCoord2f(u1,v2);	glVertex3f(s*2+x+sin(r+step2)*s,	(-ol_s)+y+cos(r+step2)*s,	0);
				glEnd();
				
			}
		}
	}
*/	}
	
	// kolikot
	PA_Texture(eurotex);
	glColor3f(1,1,1);
	
	step=7;
	
	for(i=step;i<512-step;i+=step)
	{
		if(i>player.z-step && i<player.z+10 && level1.coin[i])
		{
					float x=level1.free_place[i].x*4;
					float y=level1.free_place[i].y*4;
					
				Viewi();
				glTranslatef(x,y,-i+player.z);
				glScalef(0.2,0.2,0.2);
				
				glBegin(GL_QUAD);
					glTexCoord2f(0.0f,0.0f); glVertex3f(-1.0f, -1.0f,  0.0f);// Point 1 (Front)
					glTexCoord2f(0.5f,0.0f); glVertex3f( 1.0f, -1.0f,  0.0f);// Point 2 (Front)
					glTexCoord2f(0.5f,0.5f); glVertex3f( 1.0f,  1.0f,  0.0f);// Point 3 (Front)
					glTexCoord2f(0.0f,0.5f); glVertex3f(-1.0f,  1.0f,  0.0f);// Point 4 (Front)
				glEnd();
		}
	}

}

void DrawStuff()
{
		PA_Init3DDrawing(0.0,0.0,1.0,//x,y,z
		0.0,0.0,0.0);//eyex, eyey, eyez
		
	glColor3f(1,1,1);	
	PA_Texture(0);
	  Viewi();
		glTranslatef(player.x*4,-player.y*4,0);
		glScalef(0.05,0.005,0.01);	
		tsCube();
	  Viewi();
		glTranslatef(player.x*4,-player.y*4,0);
		glScalef(0.005,0.05,0.01);		
		tsCube();


	DrawScene();

}
